#ifndef GABA_DEFINE
struct command_continuation
{
  struct lsh_object super;
  int (*(c))(struct command_continuation *self, struct lsh_object *result);
};
extern struct lsh_class command_continuation_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_continuation_class =
{ STATIC_HEADER,
  0, "command_continuation", sizeof(struct command_continuation),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command
{
  struct lsh_object super;
  int (*(call))(struct command *self, struct lsh_object *arg, struct command_continuation *c);
};
extern struct lsh_class command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_class =
{ STATIC_HEADER,
  0, "command", sizeof(struct command),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command_simple
{
  struct command super;
  struct lsh_object * (*(call_simple))(struct command_simple *self, struct lsh_object *);
};
extern struct lsh_class command_simple_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_simple_class =
{ STATIC_HEADER,
  &command_class, "command_simple", sizeof(struct command_simple),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct command_frame
{
  struct command_continuation super;
  struct command_continuation *up;
};
extern struct lsh_class command_frame_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_command_frame_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct command_frame *i = (struct command_frame *) o;
  mark((struct lsh_object *) i->up);
}

struct lsh_class command_frame_class =
{ STATIC_HEADER,
  &command_continuation_class, "command_frame", sizeof(struct command_frame),
  do_command_frame_mark,
  NULL
};
#endif /* !GABA_DECLARE */

